SuperStrict

Import "TTextEffect.bmx"

Type TTextEffectTypewriter Extends TTextEffect

	Field charTime:Int
	field cursorChar:String

	Function Create:TTextEffectTypewriter(charTime:Int = 100, cursorChar:String = "|")
		Local o:TTextEffectTypewriter = New TTextEffectTypewriter
			o.charTime = charTime
			o.cursorChar = cursorChar
		return o
	End Function

	Method applyEffect:String(txt:String)
		Local ms:Int = MilliSecs()
		If effectTimeStart = -1 Then
			effectTimeStart = ms
		EndIf

		Local fullEffectLength:Float = charTime * txt.Length
		Local effectFactor:Float = Float(ms - effectTimeStart) / fullEffectLength

		If effectFactor > 1.0 Then
			done = true
			Return txt
		EndIf

		Local endpos:Int = txt.Length * effectFactor
		Local result:String = txt[..endpos] + cursorChar

		Return result
	End Method

End Type
